/*
TASK: lesna
NAME: Petar Ivanov
*/

#include <cstdio>
#include <algorithm>
#include <set>
#include <map>
using namespace std;

#define min(a,b) ((a)<(b)) ? (a):(b)

const int MAX_N    = 1<<20; //!!!!!!!!!!!!
const int MAX_DEST = 64;
const int MAX_POW  = 21;

int n, m, k;

struct edge {
	int to, next;
	edge () {}
	edge (int _to, int _next) : to(_to), next(_next) {}
};

struct elem {
	int a, b, lca;
	elem () {}
	elem (int _a, int _b, int _lca) : a(_a), b(_b), lca(_lca) {}
};

int vec[MAX_N], last=0;
edge buf[MAX_N];

int parent[MAX_N];
int cost_edge[MAX_N];
int cost_from_root[MAX_N];
int dest[MAX_DEST], dest_br;   // leaves

int S[MAX_N], where[MAX_N];    // for dfs

int old_num[MAX_N], new_num[MAX_N];
int first_occ[MAX_N];

int depth[MAX_N];              // from root
int lca[MAX_N][MAX_POW];

elem lca_list[64];

void input ()
{
	int i, a, b, e;

	scanf ("%d%d%d", &n, &m, &k);

	memset (vec,-1,sizeof(vec));

	parent[1] = 0;
	cost_edge[1] = 0;
	cost_from_root[1] = 0;

	for (i=0; i<m; i++) {
		scanf ("%d%d%d", &a, &b, &e);

		buf[last] = edge(b,vec[a]);
		vec[a] = last++;

		parent[b] = a;
		cost_edge[b] = e;
		cost_from_root[b] = cost_from_root[a] + e;
	}
}

void set_depth ()
{
	int l=0, i, p, br=1;

	depth[br] = 0;
	new_num[1] = br;
	S[l++] = 1;

	memcpy (where,vec,sizeof(vec));

	while (l) {
		p = S[l-1];
		depth[br] = depth[ new_num[ parent[p] ] ] + 1;
		old_num[br] = p;
		if (!first_occ[ new_num[p] ]) first_occ[ new_num[p] ] = br;
		br++;

		i = where[p];

		if (i!=-1) {
			new_num[ buf[i].to ] = br;
			S[l++] = buf[i].to;
		} else l--;

		where[p] = buf[i].next;
	}
}

inline int min_depth_ret_lca (int a, int b)
{
	return depth[a] < depth[b] ? a : b;
}

void init_lca ()
{
	int i, j;

	for (i=1; i<=2*n; i++)
		lca[i][0] = i;

	for (j=1; j<MAX_POW; j++)
		for (i=1; i<=2*n; i++)
			lca[i][j] = min_depth_ret_lca(lca[i][j-1], lca[i+(1<<(j-1))][j-1]);
}

bool lca_list_cmp (const elem &p, const elem &q)
{
	return depth[p.lca] > depth[q.lca];
}

int solve ()
{
	int i, j, shift, diff, p=0, ans=0;
	map<int,int> cnt;
	set<int> V;

	if (dest_br==0) return 0;
	if (dest_br==1) return cost_from_root[ old_num[dest[0]] ];

	sort (dest,dest+dest_br);

	for (i=0; i<dest_br; i++)
		cnt[dest[i]] = 1;

	for (i=1; i<dest_br; i++)
		if (dest[i-1]==dest[i])
			cnt[ dest[i] ]++;

	for (i=0; i<dest_br; i++)
		for (j=i+1; j<dest_br; j++) {
				for (shift=-1, diff=dest[j]-dest[i]+1; diff; diff>>=1)
					shift++;
				
				lca_list[p++] = elem( dest[i], dest[j], min_depth_ret_lca(lca[dest[i]][shift], lca[dest[j]-(1<<shift)+1][shift]) );
				lca_list[p++] = elem( dest[j], dest[i], min_depth_ret_lca(lca[dest[i]][shift], lca[dest[j]-(1<<shift)+1][shift]) );
			}

	sort (lca_list,lca_list+p,lca_list_cmp);

	for (i=0; i<p; i++) {
		if ( !V.count(lca_list[i].b) ) {
			ans += cnt[lca_list[i].b] * (cost_from_root[ old_num[lca_list[i].b] ] - cost_from_root[ old_num[lca_list[i].lca] ]/2);
			V.insert (lca_list[i].b);
		}
	}

	return ans;
}

int main ()
{
	//freopen ("lesna.in", "r", stdin);

	int i, j;

	input ();
	set_depth ();
	init_lca ();

	for (i=0; i<k; i++) {
		scanf ("%d", &dest_br);

		for (j=0; j<dest_br; j++) {
			scanf ("%d", &dest[j]);
			dest[j] = new_num[ dest[j] ];
		}

		printf ("%d\n", solve ());
	}

	return 0;
}