
/*
    FROM: National Olympiad 2008, K5
    PROB: trudna
    KEYW: dynamic programming with memory optimization
*/

#include <cstdio>
#include <cstring>
using namespace std;

// Complexity: O(T * N * K * 9)

const int MAXN = 64;
const int MAXK = 512;
const int MAXT = 512;

int N, K, T, P;
int move[] = {0, -1, +1};
char s [2048];
bool ok [4][4][4];              // Whether (i, j, k) move is possible).
int add [MAXT][MAXN];           // The value of the coin at moment i at position j.
int best [2][MAXN][MAXK][4][4]; // The dp array. (with optimization)

void input ()
{
    scanf ("%d %d %d %d", &N, &K, &T, &P);
    
    memset (add, 0, sizeof (add));
    memset (ok, true, sizeof (ok));
    
    for (int j = 0; j < P; ++j)
    {
        scanf ("%s", s);
        ok [s [0] - '0'][s [1] - '0'][s [2] - '0'] = false;
    }
    for (int j = 0; j < T; ++j)
    {
        int z;
        scanf ("%d", &z);
        for (int i = 0; i < z; ++i)
        {
            int pos, value;
            scanf ("%d %d", &pos, &value);
            add [j][pos - 1] = value;
        }
    }
}
inline void clear (int row)
{
    int j, k, p2, p1;
    for (j = 0; j < N; ++j)
        for (k = 0; k <= K; ++k)
            for (p2 = 0; p2 < 3; ++p2)
                for (p1 = 0; p1 < 3; ++p1)
                    best [row][j][k][p2][p1] = -1;
}
void solve ()
{
    clear (0);
//    best [0][0][K][0][0] = 0;
    int t, n, nn, k, nk, p2, p1, p0;
    for (n = 0; n < N; ++n)
        best [0][n][K][0][0] = 0;
    //int res = 0;
    for (t = 0; t < T; ++t)
    {
        clear ((t + 1) & 1);
        for (n = 0; n < N; ++n)
            for (k = 0; k <= K; ++k)
                for (p2 = 0; p2 < 3; ++p2)
                    for (p1 = 0; p1 < 3; ++p1)
                        if (best [t & 1][n][k][p2][p1] >= 0)
                        {
 //                           printf ("(%d, %d, %d, %d, %d, %d)\n", t, n, k, p2, p1, best [t & 1][n][k][p2][p1]);
 //                           int nn, nk;
//                            res >?= best [t & 1][n][k][p2][p1];
                            for (p0 = 0; p0 < 3; ++p0)
                                if (ok [p2][p1][p0])
                                {
                                    //printf ("moving with %d\n", p0);
                                    nn = n + move [p0];
                                    nk = k - (p0 != 0 ? 1 : 0);
//                                    printf (" = %d\n", (nn >= 0 && nn < N && nk >= 0  );
                                    if (nn >= 0 && nn < N && nk >= 0) // Repair this!
                                    {
                                        
                                    //printf ("to get (%d, %d, %d, %d, %d)\n", t + 1, nn, nk, p1, p0);
                                    //    printf ("ok..\n");
                                        /*res >?= */
                                        //best [(t + 1) & 1][nn][nk][p1][p0] >?= best [t & 1][n][k][p2][p1] + add [t][nn];
                                        if (best [(t + 1) & 1][nn][nk][p1][p0] < best [t & 1][n][k][p2][p1] + add [t][nn])
                                            best [(t + 1) & 1][nn][nk][p1][p0] = best [t & 1][n][k][p2][p1] + add [t][nn];
                                    }
                                }
                        }
    }
    int res = 0;
    for (n = 0; n < N; ++n)
        for (k = 0; k <= K; ++k)
            for (p2 = 0; p2 < 3; ++p2)
                for (p1 = 0; p1 < 3; ++p1)
                {
//                    res >?= best [T & 1][n][k][p2][p1];
                    if (res < best [T & 1][n][k][p2][p1])
                        res = best [T & 1][n][k][p2][p1];
//                    if (best [T & 1][n][k][p2][p1] >= 0)
//                        printf ("(%d, %d, %d, %d, %d, %d)\n", T, n, k, p2, p1, best [T & 1][n][k][p2][p1]);
//                    if (best [T & 1][n][k][p2][p1] == 6)
//                        printf ("%d %d %d %d %d\n", T, n, k, p2, p1);
//                    printf ("(%d, %d, %d, %d, %d) = %d\n", T, n, k, p2, p1, best [T & 1][n][k][p2][p1]);
                }
    printf ("%d\n", res);
}
int main ()
{
    input ();
    solve ();
    return 0;
}
