#include <cstdio>
#include <vector>
using namespace std;

#define node									first
#define cost									second
#define min(a, b)								((a) < (b) ? (a) : (b))
#define max(a, b)								((a) < (b) ? (b) : (a))

class R_MIN_Q
{

public:

R_MIN_Q()
{
	for(int i = 0; i < N; i ++)
	{
		update(i, INF);
	}
}

void update(int x, const int value)
{
	x += N;
	
	tree[x] = value;
	
	x >>= 1;
	
	if(tree[x << 1] < tree[(x << 1) + 1]) tree[x] = x << 1;
	else tree[x] = (x << 1) + 1;
	
	while(1 < x)
	{
		x >>= 1;
		
		if(tree[tree[x << 1]] < tree[tree[(x << 1) + 1]]) tree[x] = tree[x << 1];
		else tree[x] = tree[(x << 1) + 1];
	}
}

int query(int x, int y)
{
int ret;
	
	x += N;
	y += N;
	
	if(tree[x] < tree[y]) ret = x;
	else ret = y;
	
	x = (x + 1) >> 1;
	y = (y - 1) >> 1;
	
	while(x <= y)
	{
		if(tree[tree[x]] < tree[ret]) ret = tree[x];
		if(tree[tree[y]] < tree[ret]) ret = tree[y];
		
		x = (x + 1) >> 1;
		y = (y - 1) >> 1;
	}
	
	return ret - N;
}

private:

static const int N = 1 << 20;
static const int INF = INT_MAX;

int tree[N << 1];

};

const int MAX_N = 1 << 20;
const int MAX_S = 1 << 6;

typedef pair<int, int> PII;

int N, M, K, D, S;
vector<PII> a[MAX_N];
int level, price;
int c[MAX_N], d[MAX_N], h[MAX_N], p[MAX_N];
int s[MAX_S];
R_MIN_Q RMQ;

void Read()
{
	scanf("%d %d %d", &N, &M, &K);
	
	for(int i = 0; i < M; i ++)
	{
		int x, y, cost;
		
		scanf("%d %d %d", &x, &y, &cost);
		
		x --;
		y --;
		
		a[x].push_back(PII(y, cost));
	}
}

void DFS(int node)
{
	d[D] = node;
	h[D] = level;
	p[node] = D;
	c[node] = price;
	D ++;
	
	for(int i = 0, n = a[node].size(); i < n; i ++)
	{
		level ++;
		price += a[node][i].cost;
		
		DFS(a[node][i].node);
		
		level --;
		price -= a[node][i].cost;
		
		d[D] = node;
		h[D] = level;
		D ++;
	}
}

void Solve()
{
	D = 0;
	level = 0;
	price = 0;
	
	DFS(0);
	
	for(int i = 0; i < D; i ++)
	{
		RMQ.update(i, h[i]);
	}
	
	for(int k = 0; k < K; k ++)
	{
		scanf("%d", &S);
		
		for(int i = 0; i < S; i ++)
		{
			scanf("%d", &s[i]);
			
			s[i] --;
		}
		
		int ans = 0;
		
		for(int i = 0; i < S; i ++)
		{
			int best = c[s[i]];
			
			for(int j = 0; j < S; j ++) if(i != j)
			{
				int x = min(p[s[i]], p[s[j]]);
				int y = max(p[s[i]], p[s[j]]);
				int index = RMQ.query(x, y);
				
				best = min(best, c[s[i]] - (c[d[index]] >> 1));
			}
			
			ans += best;
		}
		
		printf("%d\n", ans);
	}
}

int main()
{
	Read();
	
	Solve();
	
	return 0;
}
