#include <iostream>
#include <algorithm>
using namespace std;

#define min(a, b)								((a) < (b) ? (a) : (b))
#define max(a, b)								((a) < (b) ? (b) : (a))

const int MAX_N = 64;
const int MAX_K = 512;
const int MAX_T = 512;
const int MAX_P = 8;
const int MAX_M = 4;

int N, K, T, P;
int p[MAX_P][3];
int c[MAX_T][MAX_N];
int dp[MAX_K][MAX_N][MAX_M][MAX_M];
int ans;

void Read()
{
	cin >> N >> K >> T >> P;
	
	for(int i = 0; i < P; i ++)
	{
		string s;
		
		cin >> s;
		
		for(int j = 0; j < 3; j ++)
		{
			p[i][j] = (s[j] - '0') + 1;
		}
	}
	
	for(int i = 0; i < T; i ++)
	{
		int r, position, value;
		
		cin >> r;
		
		for(int j = 0; j < r; j ++)
		{
			cin >> position >> value;
			
			position --;
			
			c[i][position] = value;
		}
	}
}

int rec(int k, int pos, int l0, int l1)
{
int & ret = dp[k][pos][l0][l1];
	
	if(0 <= ret) return ret;
	
	if(k == K) return ret = 0;
	
	ret = 0;
	
	for(int i = 1, j; i <= 3; i ++)
	{
		for(j = 0; j < P; j ++)
		{
			if(p[j][0] == l0 && p[j][1] == l1 && p[j][2] == i)
			{
				break;
			}
		}
		
		if(j != P) continue;
		
		if(i == 1)
		{
			ret = max(ret, c[k][pos] + rec(k + 1, pos, l1, i));
		}
		
		if(i == 2)
		{
			if(0 <= pos - 1)
			{
				ret = max(ret, c[k][pos] + rec(k + 1, pos - 1, l1, i));
			}
		}
		
		if(i == 3)
		{
			if(pos + 1 < N)
			{
				ret = max(ret, c[k][pos] + rec(k + 1, pos + 1, l1, i));
			}
		}
	}
	
	return ret;
}

void Solve()
{
	K = min(K + 1, T);
	
	memset(dp, - 1, sizeof(dp));
	
	for(int i = 0; i < N; i ++)
	{
		ans = max(ans, rec(0, i, 0, 0));
	}
}

void Write()
{
	cout << ans << "\n";
}

int main()
{
	Read();
	
	Solve();
	
	Write();
	
	return 0;
}
